import javafx.collections.ObservableList;
import javafx.geometry.Bounds;
import javafx.scene.Node;
import javafx.scene.image.Image;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.transform.Rotate;

/**
 * r
 */
public class PRSpriteBuilding extends PRSpriteT {

	private static final float[]	POINTS			= {
		-1, -2, -1,
		-1,  2, -1,
		 1,  2, -1,
		 1, -2, -1,
		 1, -2, -1,
		 1,  2, -1,
		 1,  2,  1,
		 1, -2,  1,
		-1, -2,  1,
		-1,  2,  1,
		-1,  2, -1,
		-1, -2, -1
	};

	private static final float[]	TEXCOORDS		= {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	private static final int[]		FACES			= {
		 0, 0,  1, 1,  2, 2,
		 2, 2,  3, 3,  0, 0,
		 4, 0,  5, 1,  6, 2,
		 6, 2,  7, 3,  4, 0,
		 8, 0,  9, 1, 10, 2,
		10, 2, 11, 3,  8, 0
	};

	/** C[W */
	private static Image			image			= null;

	/** ]ij */
	private static final Rotate		ROTATE_LEFT		= new Rotate( 15, Rotate.Y_AXIS);

	/** ]iEj */
	private static final Rotate		ROTATE_RIGHT	= new Rotate(-15, Rotate.Y_AXIS);

	/**
	 * 
	 */
	public static void init() {

		try{
			PRSpriteBuilding.image = PRImage.getImage("3d/image_e_town0103_s512_town0103_1.png");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param strPattern zup^[
	 * @param X␳ʒu
	 * @param pos ʒu
	 */
	public PRSpriteBuilding(PRApplication application, String strPattern, double xHosei, int pos){

		// X[p[NXĂяo
		super(application);

		try{

			// bVr[𐶐
			MeshView meshView = new MeshView();

			// bV𐶐
			TriangleMesh mesh = new TriangleMesh();

			mesh.getPoints().addAll(POINTS);
			mesh.getTexCoords().addAll(TEXCOORDS);
			mesh.getFaces().addAll(FACES);

			// }eA𐶐
			PhongMaterial material = new PhongMaterial();
			material.setDiffuseMap(image);

			// bVo^
			meshView.setMesh(mesh);
			meshView.setMaterial(material);

			// bVr[ǉ
			this.getChildren().add(meshView);

			double x = 0.0;

			// zup^[̏ꍇA
			if("".equals(strPattern)){

				// ʒu␳
				x = -3.5 + xHosei;

				// ]
				this.getTransforms().add(ROTATE_LEFT);

			// zup^[ȄꍇA
			}else if("E".equals(strPattern)){

				// ʒu␳
				x = 3.5 + xHosei;

				// ]
				this.getTransforms().add(ROTATE_RIGHT);

			} // end if zup^[

			// Xݒ
			super.setTranslateX(x);

			// Zݒ
			super.setTranslateZ(150);

			// Yݒ
			Bounds bounds = this.getBoundsInParent();
			super.setTranslateY(-bounds.getHeight() / 2);

			// xݒ
			mz = -1.0;

			// eݒ
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end priteBuilding

	/**
	 * s
	 */
	@Override
	public void run(){

		//
		// X
		//

		// ړʎ擾
		double mx = -application.getPRSpritePrusher().mx;

		// WvZ
		double x = super.getTranslateX();
		x = x + mx;

		// ړ
		super.setTranslateX(x);

		//
		// Z
		//

		// W擾
		double z = super.getTranslateZ();

		// WZ
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 0){
			// 폜
			super.remove();
		}

		// ړ
		super.setTranslateZ(z);

		//
		// 蔻
		//

		// E擾
		Bounds boundsThis = this.getBoundsInParent();

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = application.getNodeLst();

		// XvCgꗗ̌擾
		int countNodeLst = nodeLst.size();

		// XvCgꗗ̌A[v
		for(int i = 0; i < countNodeLst; i++){

			// XvCg擾
			Node node = nodeLst.get(i);

			// ȅꍇA
			if(node instanceof PRSpriteTama){

				// ĂꍇA
				if(boundsThis.intersects(node.getBoundsInParent())){

					// e֕ϊ
					PRSpriteTama spriteTama = (PRSpriteTama)node;

					// ˕ԂĂꍇA
					if(spriteTama.isRapel()){
						// ReBj[
						continue;
					}

					// e𒵂˕Ԃ
					spriteTama.rapel();

					// [v𔲂
					break;

				} // end if Ăꍇ

			} // end if ȅꍇ

		} // end for XvCgꗗ̌A[v

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.6;
	}

	@Override
	public double getHaniY() {
		return 0.8;
	}

}
