import java.util.HashMap;

import javafx.geometry.Point3D;
import javafx.collections.ObservableList;
import javafx.scene.Node;
import javafx.scene.Group;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.geometry.Bounds;
import javafx.scene.paint.Color;

/**
 * }l
 */
public class PRSpriteManel extends PRSpriteT {

	/** {XP */
	private final Color[]		COLORS = {
		Color.color(1.0, 0.4, 1.0),
		Color.color(1.0, 0.4, 0.8),
		Color.color(1.0, 0.4, 0.6),
		Color.color(1.0, 0.4, 0.6),
		Color.color(1.0, 0.4, 0.4),
		Color.color(1.0, 0.4, 0.4),
		Color.color(1.0, 0.4, 0.4)
	};

	/** XvCgO[v */
	private		PRSpriteGroupManel		spriteGroup				= null;

	/** zup^[ */
	private		String					strPattern				= null;

	/** tF[Y */
	private		int						phase					= 0;

	/**  */
	private 	int						time					= 0;

	/** px */
	private		int						angle					= 0;

	/** ϋvx */
	private 	int						life					= 2;

	/** ړ */
	private		int						way						= 1;

	/** Yn */
	private		double					yJimen					= 0;

	/** ҂ */
	private		int						timeWait				= 0;

	/** G̒eˎ */
	private		int						timeTamaTeki			= 240;

	/** ϐFp[c */
	private		Group					groupArmor				= null;
	private		Group					groupShoulder_Left		= null;
	private		Group					groupShoulder_Right		= null;

	/** ϐFp[c̃}eA */
	private		PhongMaterial			materailArmor			= null;
	private		PhongMaterial			materailShoulder_Left	= null;
	private		PhongMaterial			materailShoulder_Right	= null;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpriteManel.class, "3d/Manel.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * <pre>
	 * ^Cgp̃}lɂȂ܂B
	 * </pre>
	 * @param application PRApplication
	 * @param strParam zup^[
	 */
	public PRSpriteManel(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// IuWFNg
			ObjReader.create(this);

			// k
			super.setScaleX(0.25);
			super.setScaleY(0.25);
			super.setScaleZ(0.25);

			// Wݒ
			super.setTranslateX(-0.8);
			super.setTranslateY(-this.getBoundsInParent().getHeight() / 2);
			super.setTranslateZ(6.2);

			// ]
			Point3D p = new Point3D(0.0, 1.0, 0.0);

			// ]ݒ
			super.setRotationAxis(p);

			// ]
			super.setRotate(-30);

			// eݒ
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteManel

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param spriteGroup XvCgO[v
	 * @param strParam zup^[
	 */
	public PRSpriteManel(PRApplication application, PRSpriteGroupManel spriteGroup, String strParam){

		// X[p[NXĂяo
		super(application);

		try{

			// XvCgO[vێ
			this.spriteGroup = spriteGroup;

			// p^[ێ
			this.strPattern = strParam;

			// IuWFNg
			ObjReader.create(this);

			// k
			super.setScaleX(0.25);
			super.setScaleY(0.25);
			super.setScaleZ(0.25);

			// p^[P̏ꍇA
			if("p^[P".equals(strPattern)){

				// Wݒ
				super.setTranslateX(5.0);
				super.setTranslateY(-this.getBoundsInParent().getHeight() / 2);
				super.setTranslateZ(200);

				// ]
				Point3D p = new Point3D(0.0, 1.0, 0.0);

				// ]ݒ
				super.setRotationAxis(p);

				// x
				mz = -0.8;

			// p^[Q̏ꍇA
			}else if("p^[Q".equals(strPattern)){

				// Wݒ
				super.setTranslateX(-2.0);
				super.setTranslateY(-this.getBoundsInParent().getHeight() / 2);
				super.setTranslateZ(200);

				// x
				mz = -1.6;

			// p^[ȐꍇA
			}else if("p^[R".equals(strPattern)){

				// Wݒ
				super.setTranslateX(2.0);
				super.setTranslateY(-this.getBoundsInParent().getHeight() / 2);
				super.setTranslateZ(200);

				// x
				mz = -1.6;

			} // end if p^[

			// eݒ
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteManel

	/**
	 * RXgN^
	 * <pre>
	 * {XPp^[ɂȂ܂B
	 * </pre>
	 * @param application PRApplication
	 * @param spriteGroup XvCgO[v
	 * @param strParam zup^[
	 */
	public PRSpriteManel(PRApplication application, PRSpriteGroupManel spriteGroup, String strParam, int pos){

		// X[p[NXĂяo
		super(application);

		try{

			// XvCgO[vێ
			this.spriteGroup = spriteGroup;

			// p^[ێ
			this.strPattern = strParam;

			// IuWFNg
			HashMap<String, Group> map = ObjReader.create(this);

			// k
			super.setScaleX(0.25);
			super.setScaleY(0.25);
			super.setScaleZ(0.25);

			// ϐFp[cێ
			groupArmor = map.get("Armor");
			groupShoulder_Left = map.get("Shoulder");
			groupShoulder_Right = map.get("Shoulder.001");

			// ϐFp[c̃bVr[擾
			MeshView meshViewArmor = (MeshView)(groupArmor.getChildren().get(0));
			MeshView meshViewShoulder_Left = (MeshView)(groupShoulder_Left.getChildren().get(0));
			MeshView meshViewShoulder_Right = (MeshView)(groupShoulder_Right.getChildren().get(0));

			// ϐFp[c̃}eA擾
			materailArmor = (PhongMaterial)meshViewArmor.getMaterial();
			materailShoulder_Left = (PhongMaterial)meshViewShoulder_Left.getMaterial();
			materailShoulder_Right = (PhongMaterial)meshViewShoulder_Right.getMaterial();

			// Wݒ
			super.setTranslateX((pos - 1) * 1.5);
			super.setTranslateY(-7.0);
			super.setTranslateZ(50);

			// Ynʎ擾
			yJimen = -this.getBoundsInParent().getHeight() / 2;

			// ]
			Point3D p = new Point3D(0.0, 1.0, 0.0);

			// ]ݒ
			super.setRotationAxis(p);

			// eݒ
			application.addShadow(this, 0.6);

			// x
			my = 0.1;

			// ϋvxݒ
			life = 4;

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteManel

	/**
	 * s
	 */
	@Override
	public void run(){

		// ԁ{P
		this.time++;

		// W擾
		double x = super.getTranslateX();
		double y = super.getTranslateY();
		double z = super.getTranslateZ();

		// p^[P̏ꍇA
		if("p^[P".equals(strPattern)){

			// ړp̎Ԃ쐬
			int timeMove = time % 120;

			// ړ
			if(timeWait == 0){

				// Xړ
				x = x + (0.3 - 0.25 * (200 - z) / 200) * way;

				// px
				angle = -45 * way;

				// [܂ŗꍇA
				if(way == -1 && x < (-z / 40) ||
					way == 1 && x > ( z / 40)){

					// ړ𔽑΂ɂ
					way = -way;

					// ҂
					timeWait = 30;

					// px߂
					angle = 0;

				}

			// ҂̏ꍇA
			}else{

				// ҂ԁ|P
				timeWait--;

			}

			// Zړ
			z = z + mz;

			// ʂ̊OɂłꍇA
			if(z < 0){
				// 폜
				super.remove();
			}

			// ړ
			super.setTranslateX(x);
			super.setTranslateZ(z);

			// ]
			super.setRotate(angle);

			// 3.0b
			if(time % 180 == 0){

				// G̒e𐶐
				PRSpriteTamaTeki2 spriteTamaTeki2 = new PRSpriteTamaTeki2(application, this, 0.6);
				// G̒eǉ
				application.addNode(spriteTamaTeki2);

				// eX^[g
				application.startWaveTamaManel();

			}

		// p^[Q or p^[R ̏ꍇA
		}else if("p^[Q".equals(strPattern) || "p^[R".equals(strPattern)){

			// Zړ
			z = z + mz;

			// ʂ̊OɂłꍇA
			if(z < 0){
				// 폜
				super.remove();
			}

			// ړ
			super.setTranslateZ(z);

			// 1.5b
			if(time % 90 == 0){

				// G̒e𐶐
				PRSpriteTamaTeki2 spriteTamaTeki2 = new PRSpriteTamaTeki2(application, this, 0.4);
				// G̒eǉ
				application.addNode(spriteTamaTeki2);

				// eX^[g
				application.startWaveTamaManel();

			}

		// {XP̏ꍇA
		}else if("{XP".equals(strPattern)){

			// tF[YO
			if(phase == 0){

				// Zړ
				y = y + my;

				// ړ
				super.setTranslateY(y);

				// nʂɒA
				if(y >= yJimen){

					// nʂɒn
					y = yJimen;

					// ړ
					super.setTranslateY(y);

					// ԏ
					time = 0;

					// tF[YP
					phase = 1;

				}

			// tF[YP
			}else if(phase == 1){

				// 1.0b
				if(time < 60){

					// Ȃ

				// 1.5b
				}else if(time < 90){

					// Zړ
					z = 40 + (90.0 - time) / 30 * 10;

					// ړ
					super.setTranslateZ(z);

				// 2.0b
				}else{

					// ԏ
					time = 0;

					// tF[YQ
					phase = 2;

				}

			// tF[YQ
			}else if(phase == 2){

				// 1.0b
				if(time < 60){

					// Zړ
					z = 10 + (60.0 - time) / 60 * 30;

					// ړ
					super.setTranslateZ(z);

				// 1.5b
				}else if(time < 150){

					// Ȃ

				// 1.5b
				}else{

					// ԏ
					time = 0;

					// tF[YR
					phase = 3;

				}

			// tF[YR
			}else if(phase == 3){

				// 2.0b
				if(time < 120){

					// Yړ
					y = yJimen - 8 * Math.sin(time / 120.0 * 3.141592);

					// ړ
					super.setTranslateY(y);

					// Zړ
					z = 10 + 15 - 15 * Math.cos(time / 120.0 * 3.141592);

					// ړ
					super.setTranslateZ(z);

					// 1.25b or 1.5b
					if(time == 75 || time == 90){

						// G̒e𐶐
						PRSpriteTamaTeki2 spriteTamaTeki2 = new PRSpriteTamaTeki2(application, this, 0.4);
						// G̒eǉ
						application.addNode(spriteTamaTeki2);

						// eX^[g
						application.startWaveTamaManel();

					}

				// 3.0b
				}else{

					// ԏ
					time = 0;

					// tF[YQ
					phase = 2;

				}

			} // end if tF[Y

			// ԂA
			if(time % 12 == 0){

				// {Xo
				int indexColor = ((int)(Math.random() * 7));
				materailArmor.setDiffuseColor(COLORS[indexColor]);
				materailShoulder_Left.setDiffuseColor(COLORS[indexColor]);
				materailShoulder_Right.setDiffuseColor(COLORS[indexColor]);

			}

		} // end if p^[

		//
		// 蔻
		//

		// ĂȂꍇA
		if(!flgBomb){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// XvCg擾
				Node node = nodeLst.get(i);

				// ȅꍇA
				if(node instanceof PRSpriteTama){

					// ĂꍇA
					if(boundsThis.intersects(node.getBoundsInParent())){

						// e폜
						application.removeNode(node);

						// ϋv́|P
						life--;

						// ϋv͂ꍇA
						if(life >= 1){

							// Gς鉹X^[g
							application.startWaveTekiTaeru();

							// [v𔲂
							break;

						}

						// 
						flgBomb = true;

						// 𐶐
						PRSpriteBomb spriteBomb = new PRSpriteBomb(application, this, 0.04);

						// AvP[Vɔǉ
						application.addNode(spriteBomb);

						// _ǉ
						application.addScore(500);

						// X^[g
						application.startWaveBomb();

						// {XP̏ꍇA
						if("{XP".equals(strPattern)){
							// XvCgO[vɍ폜ʒm
							spriteGroup.removeSprite();
						}

						// [v𔲂
						break;

					} // end if Ăꍇ

				} // end if ȅꍇ

			} // end for XvCgꗗ̌A[v

		} // end if ĂȂꍇ

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.4;
	}

	/**
	 * 蔻͈Y
	 */
	@Override
	public double getHaniY() {
		return 0.4;
	}

	/**
	 * 蔻͈Z
	 */
	@Override
	public double getHaniZ() {
		return 0.4;
	}

}
