import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;

/**
 * ^C
 */
public class PRSpriteTile extends PRSprite {

	private static float[]		POINTS		= {
		-1.0f, 0,  2.0f,
		-1.0f, 0, -2.0f,
		 1.0f, 0, -2.0f,
		 1.0f, 0,  2.0f
	};

	private static float[]		TEXCOORDS   = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	private static int[]		FACES		= {
		0, 0, 1, 0, 2, 0,
		2, 0, 3, 0, 0, 0
	};

	/** xZ */
	private		double			mz			= 0.0;

	/** }eA */
	private		PhongMaterial	material	= null;

	/**
	 * 
	 */
	public static void init() {

		try{
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 */
	public PRSpriteTile(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// ʒu␳
			int posX = 0;

			// }eA𐶐
			material = new PhongMaterial();
			material.setDiffuseColor(Color.FORESTGREEN);

			// z[v
			for(int z = 200; z > 0; z = z - 4){

				// ʒu␳
				posX = (posX == 0)?1: 0;

				// x[v
				for(int x = -32; x < 32; x = x + 4){

					// bVr[𐶐
					MeshView meshView = new MeshView();

					// bV𐶐
					TriangleMesh mesh = new TriangleMesh();

					mesh.getPoints().addAll(POINTS);
					mesh.getTexCoords().addAll(TEXCOORDS);
					mesh.getFaces().addAll(FACES);

					// bVo^
					meshView.setMesh(mesh);
					meshView.setMaterial(material);

					// Xݒ
					meshView.setTranslateX(x + posX * 2);

					// Yݒ
					meshView.setTranslateY(-0.0001);

					// Zݒ
					meshView.setTranslateZ(z);

					// bVr[ǉ
					this.getChildren().add(meshView);

				} // end for x[v

			} // end for z[v

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteTile

	/**
	 * Xe[Wݒ
	 * @param stage Xe[W
	 */
	public void setStage(int stage){

		// Xe[WPFtHXgEO[
		if(stage == 1){

			this.setVisible(true);
			material.setDiffuseColor(Color.FORESTGREEN);

			mz = -0.6;

		// Xe[WQFS[fbhEXs[hAbv
		}else if(stage == 2){

			material.setDiffuseColor(Color.GOLDENROD);

			mz = -1.0;

		// Xe[WRFlCr[EXs[hAbv
		}else if(stage == 3){

			material.setDiffuseColor(Color.NAVY);

			mz = -1.0;

		// Xe[WSFB
		}else if(stage == 4){

			this.setVisible(false);

		// Xe[WTF̂܂܉B܂
		}else if(stage == 5){

		} // end if Xe[W

	} // end setStage

	/**
	 * s
	 */
	@Override
	public void run(){

		//
		// X
		//

		// W擾
		double x = super.getTranslateX();

		// ړʎ擾
		double mx = -application.getPRSpritePrusher().mx;

		// WvZ
		x = x + mx;

		// WĔzu
		if(x < -10){
			x = x + 10;
		}else if(x > 10){
			x = x - 10;
		}

		// ړ
		super.setTranslateX(x);

		//
		// Z
		//

		// W擾
		double z = super.getTranslateZ();

		// WZ
		z = z + mz;

		// [v^C~ȌꍇA
		if(z <= -16){
			// ʒu߂
			z = 0;;
		}

		// ړ
		super.setTranslateZ(z);

	} // end run

}
