import java.util.HashMap;

import javafx.geometry.Point3D;
import javafx.scene.Group;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.transform.Rotate;
import javafx.scene.transform.Translate;

/**
 * ^Cg|Prusher
 */
public class PRSpriteTitle extends PRSprite implements PRConstant {

	/** XvCg` */
	private static final String	TITLE_P			= "PRSpriteTITLE_Prusher_P";
	private static final String	TITLE_R1		= "PRSpriteTITLE_Prusher_R";
	private static final String	TITLE_U			= "PRSpriteTITLE_Prusher_U";
	private static final String	TITLE_S			= "PRSpriteTITLE_Prusher_S";
	private static final String	TITLE_H			= "PRSpriteTITLE_Prusher_H";
	private static final String	TITLE_E			= "PRSpriteTITLE_Prusher_E";
	private static final String	TITLE_R2		= "PRSpriteTITLE_Prusher_R";

	private static final String[]	TitleS		= {
		TITLE_P	,
		TITLE_R1,
		TITLE_U	,
		TITLE_S	,
		TITLE_H	,
		TITLE_E	,
		TITLE_R2
	};

	/** ݒp */
	private static final Rotate INIT_ROTATE		= new Rotate(90, Rotate.X_AXIS);
	private static final Translate INIT_TRANSLATE = new Translate(0.0, 0.25, -0.25);

	/** XvCg */
	private static final int	COUNT_SPRITES	= 7;

	/** ZŒʒu */
	private static final double	Z				= 8.0;

	/** tF[Y */
	private		int				phase			= 0;

	/**  */
	private		int				time			= 0;

	/** ]x */
	private		double			s				= 4.0;

	/** xZ */
	private		double			mz				= -2.0;

	/** XvCgꗗ */
	private		Group[]			sprites			= null;

	/** ҂Ԉꗗ */
	private		int[]			timeWaits		= null;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(TITLE_P , "3d/TitleP.obj");
			ObjReader.init(TITLE_R1, "3d/TitleR.obj");
			ObjReader.init(TITLE_U , "3d/TitleU.obj");
			ObjReader.init(TITLE_S , "3d/TitleS.obj");
			ObjReader.init(TITLE_H , "3d/TitleH.obj");
			ObjReader.init(TITLE_E , "3d/TitleE.obj");
			ObjReader.init(TITLE_R2, "3d/TitleR.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 */
	public PRSpriteTitle(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// ]
			Point3D p = new Point3D(1.0, 0.0, 0.0);

			// XvCgꗗ𐶐
			sprites = new Group[COUNT_SPRITES];

			// ҂Ԉꗗ𐶐
			timeWaits = new int[COUNT_SPRITES];

			// }eA𐶐
			PhongMaterial material = new PhongMaterial();
			material.setDiffuseColor(Color.web("808080"));

			// XvCgꗗ̌A[v
			for(int i = 0; i < COUNT_SPRITES; i++){

				// XvCg𐶐
				Group sprite = new Group();

				// XvCgꗗɐݒ
				sprites[i] = sprite;

				// IuWFNg
				HashMap<String, Group> map = ObjReader.create(sprite, TitleS[i]);

				// ]
				sprite.getTransforms().add(INIT_ROTATE);
				sprite.getTransforms().add(INIT_TRANSLATE);

				// ]ݒ
				sprite.setRotationAxis(p);

				// bVr[擾
				Group group = map.get("Text");
				MeshView meshView = ((MeshView)group.getChildren().get(0));

				// }eAo^
				meshView.setMaterial(material);

				// O[vo^
				this.getChildren().add(sprite);

				// ҂Ԑݒ
				timeWaits[i] = 30 * i;

			} // end for XvCgꗗ̌A[v

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteTitle

	/**
	 * s
	 */
	@Override
	public void run(){

		// tF[YO
		if(phase == 0){

			// ԏ
			time = 0;

			// tF[YP
			phase = 1;

		// tF[YP
		}else if(phase == 1){

			// XvCgꗗ̌A[v
			for(int i = 0; i < COUNT_SPRITES; i++){

				// XvCg擾
				Group sprite = sprites[i];

				// W擾
				double z = sprite.getTranslateZ();

				// WZ
				z = z + mz;

				// ʒu܂ŗĂꍇA
				if(z <= Z){
					// Z␳
					z = Z;
				}

				// Wݒ
				sprite.setTranslateZ(z);

			} // end for XvCgꗗ̌A[v

			// XvCg擾
			Group sprite = sprites[COUNT_SPRITES - 1];

			// W擾
			double z = sprite.getTranslateZ();

			// ʒu܂ŗĂꍇA
			if(z <= Z){

				// ԏ
				time = 0;
				// tF[YQ
				phase = 2;

			}

		// tF[YQ
		}else if(phase == 2){

			// ԁ{P
			time++;

			// ԂoA
			if(time > 60){

				// ԏ
				time = 0;
				// tF[YR
				phase = 3;

				// tF[Yݒ
				super.application.setPhase(PHASE_TITLE_3);

			}

		// tF[YR
		}else if(phase == 3){

			// XvCgꗗ̌A[v
			for(int i = 0; i < COUNT_SPRITES; i++){

				// XvCg擾
				Group sprite = sprites[i];

				// Ԃ
				if(timeWaits[i] <= 0){

					// px擾
					int rotate = (int)sprite.getRotate();

					// 360xȏ̏ꍇA
					if(rotate >= 360){

						// ҂Ԃݒ
						timeWaits[i] = 180;

						// ]ftHgl
						sprite.setRotate(0);

					// 360x̏ꍇA
					}else{

						// ]
						sprite.setRotate(sprite.getRotate() + this.s);

					}

				// ԂĂȂꍇA
				}else{
					// ҂Ԃ炷
					timeWaits[i]--;
				}

			} // end for XvCgꗗ̌A[v

		}

	} // end run

	/**
	 * 
	 */
	public void initPosition(){

		// tF[YO
		phase = 0;

		// XvCgꗗ̌A[v
		for(int i = 0; i < COUNT_SPRITES; i++){

			// XvCg擾
			Group sprite = sprites[i];

			// Wݒ
			sprite.setTranslateX(0.5 * i - 1.75);
			sprite.setTranslateY(-2.0);
			sprite.setTranslateZ(200.0 + i * 50);

			// ]
			sprite.setRotate(0);

			// ҂Ԑݒ
			timeWaits[i] = 30 * i;

		} // end for XvCgꗗ̌A[v

	} // end initPosition

	/**
	 * ^CgXLbv
	 */
	public void skipTitle(){

		// XvCgꗗ̌A[v
		for(int i = 0; i < COUNT_SPRITES; i++){
			// Zݒ
			sprites[i].setTranslateZ(Z);
		} // end for XvCgꗗ̌A[v

		// ԏ
		time = 0;

		// tF[YQ
		phase = 2;

	} // end skipTitle

}
